-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local im  = ui_imgui

local C = {}

C.name = 'AI Special Parameters'
C.description = 'Sets additional parameters for an AI vehicle.'
C.category = 'once_instant'
C.color = im.ImVec4(0.4, 0.9, 1.0, 0.9)
C.author = 'BeamNG'
C.tmpSecondPassFlag = true
C.pinSchema = {
  {dir = 'in', type = 'number', name = 'vehId', description = 'Vehicle id.'},
  {dir = 'in', type = 'number', name = 'edgeDist', description = 'Minimum distance from the edge of the road.'},
  {dir = 'in', type = 'number', name = 'turnForce', description = 'Turn force coefficient.'},
  {dir = 'in', type = 'number', name = 'awarenessForce', description = 'Vehicle awareness force coefficient.'}
}

C.tags = {}

function C:workOnce()
  local obj = be:getObjectByID(self.pinIn.vehId.value)
  if not obj then return end

  if self.pinIn.edgeDist.value then
    obj:queueLuaCommand('ai.setParameters({edgeDist = '..self.pinIn.edgeDist.value..'})')
  end
  if self.pinIn.turnForce.value then
    obj:queueLuaCommand('ai.setParameters({turnForceCoef = '..self.pinIn.turnForce.value..'})')
  end
  if self.pinIn.awarenessForce.value then
    obj:queueLuaCommand('ai.setParameters({awarenessForceCoef = '..self.pinIn.awarenessForce.value..'})')
  end
end

return _flowgraph_createNode(C)
